/*
 *  TOPPERS ECHONET Lite Communication Middleware
 *
 *  Copyright (C) 2015 Cores Co., Ltd. Japan
 *
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 *
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 *
 *  @(#) $Id: wamp_callee.h 108 2015-06-11 09:15:46Z coas-nagasima $
 */

#ifndef WAMP_CALLEE_H
#define WAMP_CALLEE_H

typedef struct wamp_callee
{
	struct wamp_state *s;
	int id;
} wamp_callee_t;

void wamp_callee_registered(wamp_callee_t *callee);
void wamp_callee_registered_request_id(wamp_callee_t *s, const char *value);
void wamp_callee_registered_registration_id(wamp_callee_t *s, const char *value);
void wamp_callee_registered_close(struct wamp_state *s);

void wamp_callee_unregistered(wamp_callee_t *callee);
void wamp_callee_unregistered_request_id(wamp_callee_t *s, const char *value);
void wamp_callee_unregistered_close(struct wamp_state *s);

void wamp_callee_invocation(wamp_callee_t *callee);
void wamp_callee_invocation_request_id(wamp_callee_t *s, const char *value);
void wamp_callee_invocation_registration_id(wamp_callee_t *s, const char *value);
void wamp_callee_invocation_details(wamp_callee_t *s, const char *value);
void wamp_callee_invocation_details_param(wamp_callee_t *s, jsonsl_action_t action,
	struct jsonsl_state_st *state, const char *buf);
void wamp_callee_invocation_arguments(wamp_callee_t *s, const char *value);
void wamp_callee_invocation_arguments_param(wamp_callee_t *s, jsonsl_action_t action,
	struct jsonsl_state_st *state, const char *buf);
void wamp_callee_invocation_argumentskw(wamp_callee_t *s, const char *value);
void wamp_callee_invocation_argumentskw_param(wamp_callee_t *s, jsonsl_action_t action,
	struct jsonsl_state_st *state, const char *buf);
void wamp_callee_invocation_close(struct wamp_state *s);

void wamp_callee_interrupt(wamp_callee_t *callee);
void wamp_callee_interrupt_request_id(wamp_callee_t *s, const char *value);
void wamp_callee_interrupt_options(wamp_callee_t *s, const char *value);
void wamp_callee_interrupt_options_param(wamp_callee_t *s, jsonsl_action_t action,
	struct jsonsl_state_st *state, const char *buf);
void wamp_callee_interrupt_close(struct wamp_state *s);

#endif // WAMP_CALLEE_H
